<template>
  <BaseMap
    :style="mapStyle"
    :center="centroidLatLng"
    :bounds="bounds"
    :overlays-config="mapOverlays"
    :current-plot-id="plot && plot.id || null"
  />
</template>

<script>
import * as L from 'leaflet'
import BaseMap from 'src/components/BaseMap'
import { getDefaultOverlayLayersConfig, getHoldingCampaignPlotsLayer } from 'src/services/map/layers/layer-configs'
import queryPlotMap from 'src/pages/holding-campaign/plot/graphql/queryPlotMap'

export default {
  name: 'PlotMap',
  components: {
    BaseMap
  },
  props: {
    plotId: {
      type: Number,
      required: true
    },
    mapStyle: {
      type: String,
      default: ''
    }
  },
  apollo: {
    plot: {
      query: queryPlotMap,
      notifyOnNetworkStatusChange: true,
      variables () {
        return {
          plotId: this.plotId
        }
      }
    }
  },
  computed: {
    centroidLatLng () {
      if (this.plot && this.plot.centroid) {
        return [this.plot.centroid.coordinates[1], this.plot.centroid.coordinates[0]]
      } else {
        return null
      }
    },
    bounds () {
      const plotBboxCoords = this.plot?.bbox?.coordinates
      if (plotBboxCoords) {
        const bounds = L.polygon(plotBboxCoords).getBounds().pad(0.2)
        return [
          [bounds.getWest(), bounds.getNorth()],
          [bounds.getEast(), bounds.getSouth()]
        ]
      } else {
        return null
      }
    },
    mapOverlays () {
      const options = {
        displayProtectedSiteNatura2000: true,
        displayRegulationZoneNVZ: true,
        displayHydrographySurfaceWater: false,
        displayHydrographyWaterCourse: false,
        displaySoilPublicSamples: false
      }
      const overlays = getDefaultOverlayLayersConfig(options)

      // add the holding campaign plots
      const holdingCampaignPlotsLayer = {
        ...getHoldingCampaignPlotsLayer(true, { holdingCampaignId: this.$store.state.fastplatform.holdingCampaign.id }),
        currentPlotId: this.plotId,
        hideCurrentPlot: true
      }
      overlays.push(holdingCampaignPlotsLayer)

      // add the selected plot in a separate plot to make sure it is not drawn over by other plots
      const plotLayer = {
        ...getHoldingCampaignPlotsLayer(true, { plotId: this.plotId }),
        title: this.$pgettext('Plot of agricultural land', 'Selected plot'),
        currentPlotId: this.plotId,
        highlighted: true
      }
      overlays.push(plotLayer)

      return overlays
    }
  }
}
</script>
